/* SPDX-FileCopyrightText: NVIDIA CORPORATION & AFFILIATES
 * Copyright (c) 2022-2024 NVIDIA CORPORATION & AFFILIATES. All rights reserved.
 *
 * NVIDIA CORPORATION, its affiliates and licensors retain all intellectual
 * property and proprietary rights in and to this material, related
 * documentation and any modifications thereto. Any use, reproduction,
 * disclosure or distribution of this material and related documentation
 * without an express license agreement from NVIDIA CORPORATION or
 * its affiliates is strictly prohibited.
 */

#ifndef _HWS_BUDDY_H_
#define _HWS_BUDDY_H_

struct buddy_mem {
	unsigned long **bits;
	unsigned int *num_free;
	uint32_t max_order;
};

struct buddy_mem *buddy_create(uint32_t max_order);

int buddy_init(struct buddy_mem *buddy, uint32_t max_order);

void buddy_cleanup(struct buddy_mem *buddy);

int buddy_alloc_mem(struct buddy_mem *buddy, int order);

void buddy_free_mem(struct buddy_mem *buddy, uint32_t seg, int order);

#endif /* _HWS_BUDDY_H_ */
