/* SPDX-FileCopyrightText: NVIDIA CORPORATION & AFFILIATES
 * Copyright (c) 2022-2024 NVIDIA CORPORATION & AFFILIATES. All rights reserved.
 *
 * NVIDIA CORPORATION, its affiliates and licensors retain all intellectual
 * property and proprietary rights in and to this material, related
 * documentation and any modifications thereto. Any use, reproduction,
 * disclosure or distribution of this material and related documentation
 * without an express license agreement from NVIDIA CORPORATION or
 * its affiliates is strictly prohibited.
 */

#ifndef _HWS_CRC_H_
#define _HWS_CRC_H_

/* Ethernet AUTODIN II CRC32 (little-endian)
 * CRC32_POLY 0xedb88320
 */
uint32_t crc32_calc(uint8_t *p, size_t len);

/* Standard CRC16 calculation using the crc_tab16 param to indicate
 * the pre-calculated polynome hash values.
 * CRC16_POLY  0x100b
 */
uint16_t crc16_calc(uint8_t *p, size_t len);

#endif /* _HWS_CRC_H_ */
