/* Copyright (c) <2024> NVIDIA CORPORATION & AFFILIATES. All rights reserved.
 *
 * NVIDIA CORPORATION, its affiliates and licensors retain all intellectual
 * property and proprietary rights in and to this material, related
 * documentation and any modifications thereto. Any use, reproduction,
 * disclosure or distribution of this material and related documentation
 * without an express license agreement from NVIDIA CORPORATION or
 * its affiliates is strictly prohibited.
 */

#ifndef MLX5DV_HWS_PARSER_H
#define MLX5DV_HWS_PARSER_H

struct mlx5dv_hws_parser_sampler {
	struct mlx5dv_hws_parser_node *node;
	struct mlx5dv_hws_parser_sampler_cfg cfg;
	struct list_node next;
	uint32_t id;
	uint32_t binded;
	struct cmd_flex_sample_info_query info_query;
	struct mlx5dv_devx_obj *geneve_obj;
};

struct mlx5dv_hws_parser_arc {
	struct mlx5dv_hws_context *ctx;
	struct mlx5dv_hws_parser_graph *graph;
	struct mlx5dv_hws_parser_arc_cfg cfg;

	struct list_node src_next;
	struct list_node dst_next;
};

struct mlx5dv_hws_parser_node {
	struct mlx5dv_hws_parser_graph *graph;
	struct mlx5dv_hws_parser_node_cfg cfg;
	struct mlx5dv_devx_obj *obj;

	struct list_node next;
	struct list_head arc_src_head;
	struct list_head arc_dst_head;
	struct list_head sampler_head;
	int refcount;
	bool binded;
};

struct mlx5dv_hws_parser_graph {
	struct mlx5dv_hws_context *ctx;
	struct list_head head;
	int refcount;
	bool binded;
};

#endif
