/* SPDX-FileCopyrightText: NVIDIA CORPORATION & AFFILIATES
 * Copyright (c) 2022-2024 NVIDIA CORPORATION & AFFILIATES. All rights reserved.
 *
 * NVIDIA CORPORATION, its affiliates and licensors retain all intellectual
 * property and proprietary rights in and to this material, related
 * documentation and any modifications thereto. Any use, reproduction,
 * disclosure or distribution of this material and related documentation
 * without an express license agreement from NVIDIA CORPORATION or
 * its affiliates is strictly prohibited.
 */

#ifndef _HWS_RESOURCE_H_
#define _HWS_RESOURCE_H_

struct mlx5dv_hws_resource {
	struct mlx5dv_hws_context *ctx;
	enum mlx5dv_hws_resource_type type;
	struct mlx5dv_devx_obj *devx_obj;
	struct resource_index_pool *ipool;
	bool user_devx_obj;
};

static inline bool resource_type_is_arg(enum mlx5dv_hws_resource_type type)
{
	return (type >= MLX5DV_HWS_RESOURCE_TYPE_ARGUMENT_64B &&
		type <= MLX5DV_HWS_RESOURCE_TYPE_ARGUMENT_256B);
}

uint32_t resource_arg_gran_get(enum mlx5dv_hws_resource_type resource_type);

int
resource_enqueue_aso_wqe(struct mlx5dv_hws_resource *resource,
			 struct send_engine *queue,
			 __be32 *aso_wqe,
			 size_t wqe_len,
			 struct mlx5dv_hws_resource_enqueue_aso_attr *attr);

#endif /* _HWS_RESOURCE_H_ */
